﻿------------------------------
--      Are you local?      --
------------------------------

local boss = BB["Baron Geddon"]
local L = AceLibrary("AceLocale-2.2"):new("BigWigs"..boss)

local db = nil
local fmt = string.format
local CheckInteractDistance = CheckInteractDistance
local pName = UnitName("player")

----------------------------
--      Localization      --
----------------------------

L:RegisterTranslations("enUS", function() return {
	bomb_message_you = "You are the bomb!",
	bomb_message_other = "%s is the bomb!",

	bombtimer_bar = "%s: Living Bomb",
	inferno_bar = "Inferno",
	service_bar = "Last Service",

	service_message = "Last Service, Geddon exploding in 5sec!",
	inferno_message = "Inferno for 10sec!",

	cmd = "Baron",

	service = "Last service",
	service_desc = "Timer bar for Geddon's last service.",

	inferno = "Inferno",
	inferno_desc = "Timer bar for Geddons Inferno.",

	bombtimer = "Bar for when the bomb goes off",
	bombtimer_desc = "Shows a 10 second bar for when the bomb goes off at the target.",

	youbomb = "You are the bomb alert",
	youbomb_desc = "Warn when you are the bomb",

	elsebomb = "Someone else is the bomb alert",
	elsebomb_desc = "Warn when others are the bomb",

	icon = "Raid Icon on bomb",
	icon_desc = "Put a Raid Icon on the person who's the bomb. (Requires promoted or higher)",
} end)

L:RegisterTranslations("zhCN", function() return {
	bomb_message_you = "你是炸弹人！远离人群！",
	bomb_message_other = "%s 是炸弹人！远离人群！",

	bombtimer_bar = "%s: 活化炸弹",
	inferno_bar = "地狱火",
	service_bar = "最后次服务",

	service_message = "最后一次服务，5秒后迦顿爆炸！",
	inferno_message = "10秒地狱火！",

	service = "最后服务计时条",
	service_desc = "显示迦顿男爵最后次服务的计时条.",
	
	inferno = "地狱火计时条",
	inferno_desc = "显示迦顿男爵地狱火的计时条.",

	bombtimer = "炸弹人计时条",
	bombtimer_desc = "当玩家成为炸弹人目标，将显示一个10秒的计时条.",

	youbomb = "玩家炸弹警报",
	youbomb_desc = "你成为炸弹时发出警报",

	elsebomb = "队友炸弹警报",
	elsebomb_desc = "队友成为炸弹时发出警报",

	icon = "设置炸弹图标",
	icon_desc = "在成为炸弹的队友头上标记骷髅图标（需要助理或领袖权限）",
} end)

L:RegisterTranslations("zhTW", function() return {
	bomb_message_you = "你是炸彈人！遠離人群！",
	bomb_message_other = "%s是炸彈人！遠離人群！",

	bombtimer_bar = "%s: 活化炸彈",
	inferno_bar = "地獄火",
	service_bar = "最後自爆",

	service_message = "5 秒後迦頓爆炸！",
	inferno_message = "施放地獄火10秒！",

	service = "最後自爆計時條",
	service_desc = "顯示迦頓男爵最後自爆的計時條.",

	inferno = "地獄火計時條",
	inferno_desc = "顯示迦頓男爵地獄火的計時條.",

	bombtimer = "炸彈爆炸計時條",
	bombtimer_desc = "顯示活化炸彈目標 10 秒後爆炸的計時條",

	youbomb = "玩家炸彈警報",
	youbomb_desc = "你成為炸彈時發出警報",

	elsebomb = "隊友炸彈警報",
	elsebomb_desc = "隊友成為炸彈時發出警報",

	icon = "炸彈標記",
	icon_desc = "在成為炸彈的隊友頭上標記（需要助理或領隊權限）",
} end)

L:RegisterTranslations("koKR", function() return {
	bomb_message_you = "당신은 폭탄입니다!",
	bomb_message_other = "%s님이 폭탄입니다!",

	bombtimer_bar = "%s: 살아있는 폭탄",
	inferno_bar = "불지옥",
	service_bar = "마지막 임무",

	service_message = "마지막 임무, 게돈 폭발 5초전!",
	inferno_message = "10초동안 불지옥!",


	service = "마지막 임무",
	service_desc = "게돈의 마지막 임무에 대한 타이머 바",

	inferno = "불지옥",
	inferno_desc = "게돈 불지옥에 대한 타이머 바.",

	bombtimer = "폭탄에 대한 바",
	bombtimer_desc = "대상에서 폭탄이 사라질 때에 대한 10초 바를 표시합니다.",

	youbomb = "자신의 폭탄 경고",
	youbomb_desc = "자신이 폭탄 일때 경고",

	elsebomb = "타인의 폭탄 경고",
	elsebomb_desc = "타인이 폭탄 일때 경고",

	icon = "폭탄에 공격대 아이콘 표시",
	icon_desc = "폭탄인 사람에게 공격대 아이콘 표시. (승급자 이상 요구)",
} end)

L:RegisterTranslations("deDE", function() return {
	bomb_message_you = "Du bist die Bombe!",
	bomb_message_other = "%s ist die Bombe!",

	bombtimer_bar = "%s: Lebende Bombe",
	inferno_bar = "Inferno",
	service_bar = "Letzter Dienst",

	service_message = "Letzter Dienst! Baron Geddon explodiert in 5 Sekunden!",
	inferno_message = "Inferno f\195\188r 10 Sekunden!",

	service = "Letzter Dienst",
	service_desc = "Timer Balken f\195\188r Baron Geddons letzten Dienst.",

	inferno = "Inferno",
	inferno_desc = "Timer Balken f\195\188r Baron Geddons Inferno.",

	bombtimer = "Bomben Timer",
	bombtimer_desc = "Zeigt einen 10 Sekunden Timer f\195\188r die Explosion der Lebenden Bombe.",

	youbomb = "Du bist die Bombe",
	youbomb_desc = "Warnung, wenn Du die Bombe bist.",

	elsebomb = "X ist die Bombe",
	elsebomb_desc = "Warnung, wenn andere Spieler die Bombe sind",

	icon = "Symbol",
	icon_desc = "Platziert ein Symbol \195\188ber dem Spieler, der die Bombe ist. (Ben\195\182tigt Anf\195\188hrer oder Bef\195\182rdert Status.)",
} end)

L:RegisterTranslations("frFR", function() return {
	bomb_message_you = "Vous êtes la bombe !",
	bomb_message_other = "%s est la bombe !",

	bombtimer_bar = "%s : Bombe vivante",
	inferno_bar = "Inferno",
	service_bar = "Dernier service",

	service_message = "Dernier service, Geddon explose dans 5 sec. !",
	inferno_message = "Inferno pendant 10 sec. !",

	service = "Dernier service",
	service_desc = "Préviens quand Geddon utilise son Dernier service.",

	inferno = "Inferno",
	inferno_desc = "Préviens quand Geddon utilise son Inferno.",

	bombtimer = "Barre d'explosion de la bombe",
	bombtimer_desc = "Affiche une barre de 10 sec. indiquant quand la bombe explose sur la cible.",

	youbomb = "Bombe vivante sur vous",
	youbomb_desc = "Préviens quand vous subissez les effets de la Bombe vivante.",

	elsebomb = "Bombe vivante sur les autres",
	elsebomb_desc = "Préviens quand un joueur subit les effets de la Bombe vivante.",

	icon = "Icône",
	icon_desc = "Place une icône de raid sur le dernier joueur affecté par la Bombe vivante (nécessite d'être promu ou mieux).",
} end)

----------------------------------
--      Module Declaration      --
----------------------------------

local mod = BigWigs:NewModule(boss)
mod.zonename = BZ["Molten Core"]
mod.enabletrigger = boss
mod.guid = 12056
mod.toggleoptions = {"inferno", "service", -1, "bombtimer", "youbomb", "elsebomb", "icon", "proximity", "bosskill"}
mod.revision = tonumber(("$Revision: 174 $"):sub(12, -3))
mod.proximityCheck = function( unit ) return CheckInteractDistance( unit, 3 ) end

------------------------------
--      Initialization      --
------------------------------

function mod:OnEnable()
	self:AddCombatListener("SPELL_AURA_APPLIED", "Bomb", 20475)
	self:AddCombatListener("SPELL_CAST_SUCCESS", "Inferno", 19695)
	self:AddCombatListener("SPELL_CAST_SUCCESS", "Service", 20478)
	self:AddCombatListener("UNIT_DIED", "BossDeath")

	db = self.db.profile
end

------------------------------
--      Event Handlers      --
------------------------------

function mod:Bomb(player)
	local other = fmt(L["bomb_message_other"], player)
	if player == pName and db.youbomb then
		self:CancelScheduledEvent("cancelProx")
		self:TriggerEvent("BigWigs_ShowProximity", self)
		self:ScheduleEvent("cancelProx", "BigWigs_HideProximity", 10, self)
		self:LocalMessage(L["bomb_message_you"], "Personal", 20475)
		self:WideMessage(other)
	elseif db.elsebomb then
		self:IfMessage(other, "Attention", 20475)
		self:Whisper(player, L["bomb_message_you"])
	end

	if db.bombtimer then
		self:Bar(fmt(L["bombtimer_bar"], player), 10, "Spell_Shadow_MindBomb", "Red")
	end

	if db.icon then
		self:Icon(player)
	end
end

function mod:Inferno()
	if db.inferno then
		self:Bar(L["inferno_bar"], 10, "Spell_Fire_SealOfFire", "Orange")
		self:IfMessage(L["inferno_message"], "Important", 19695)
	end
end

function mod:Service()
	if db.service then
		self:Bar(L["service_bar"], 5, "Spell_Shadow_MindBomb", "Red")
		self:Message(L["service_message"], "Important", 20478)
	end
end
