﻿------------------------------
--      Are you local?      --
------------------------------

local boss = BB["Garr"]
local L = AceLibrary("AceLocale-2.2"):new("BigWigs"..boss)

local db = nil

----------------------------
--      Localization      --
----------------------------

L:RegisterTranslations("enUS", function() return {
	cmd = "Garr",

	pulse = "Antimagic Pulse Bar",
	pulse_desc = "Show a bar for Antimagic Pulse",

	pulse_bar = "Antimagic Pulse",
} end)

L:RegisterTranslations("frFR", function() return {
	pulse = "Barre Impulsion anti-magique",
	pulse_desc = "Affiche une barre temporelle pour l'Impulsion anti-magique.",

	pulse_bar = "Impulsion anti-magique",
} end)

L:RegisterTranslations("zhCN", function() return {
	pulse = "反魔法脉冲计时条",
	pulse_desc = "显示一个反魔法脉冲的计时条",

	pulse_bar = "反魔法脉冲",
} end)


L:RegisterTranslations("zhTW", function() return {
	pulse = "Antimagic Pulse Bar",
	pulse_desc = "Show a bar for Antimagic Pulse",

	pulse_bar = "Antimagic Pulse",
} end)

----------------------------------
--      Module Declaration      --
----------------------------------

local mod = BigWigs:NewModule(boss)
mod.zonename = BZ["Molten Core"]
mod.enabletrigger = boss
mod.guid = 12057
mod.toggleoptions = {"pulse", "bosskill"}
mod.revision = tonumber(("$Revision: 174 $"):sub(12, -3))

------------------------------
--      Initialization      --
------------------------------

function mod:OnEnable()
	self:AddCombatListener("SPELL_CAST_SUCCESS", "Pulse", 19492)
	self:AddCombatListener("UNIT_DIED", "BossDeath")
	
	db = self.db.profile
end

------------------------------
--      Event Handlers      --
------------------------------

function mod:Pulse()
	if db.pulse then
		self:Bar(L["pulse_bar"], 18, 19492)
	end
end
