﻿------------------------------
--      Are you local?      --
------------------------------

local boss = BB["Gehennas"]
local L = AceLibrary("AceLocale-2.2"):new("BigWigs"..boss)

local db = nil
local pName = UnitName("player")

----------------------------
--      Localization      --
----------------------------

L:RegisterTranslations("enUS", function() return {
	warn1 = "5 seconds until Gehennas' Curse!",
	warn2 = "Gehennas' Curse - 30 seconds until next!",

	bar1text = "Gehennas' Curse",

	cmd = "Gehennas",

	curse = "Gehennas' Curse alert",
	curse_desc = "Warn for Gehennas' Curse",

	fire = "Rain of Fire",
	fire_desc = "Warn when Rain of Fire is on you.",
	fire_you = "Rain of Fire on YOU!",
} end)

L:RegisterTranslations("zhCN", function() return {
	warn1 = "5秒后发动基赫纳斯的诅咒！",
	warn2 = "基赫纳斯的诅咒 - 30秒后再次发动",

	bar1text = "基赫纳斯的诅咒",
	
	curse = "诅咒警报",
	curse_desc = "诅咒警报",

	fire = "火焰之雨",
	fire_desc = "当你受到火焰之雨时发出警报。",
	fire_you = ">你< 火焰之雨！",
} end)

L:RegisterTranslations("zhTW", function() return {
	warn1 = "群體詛咒 5 秒後發動！",
	warn2 = "群體詛咒 - 30 秒後再次發動",

	bar1text = "基赫納斯的詛咒",

	curse = "詛咒警報",
	curse_desc = "當基赫納斯使用反治療群體詛咒時發出警報",

	fire = "火焰之雨",
	fire_desc = "當你在火焰之雨範圍時發出警報",
	fire_you = "你受到火焰之雨!",
} end)

L:RegisterTranslations("koKR", function() return {
	warn1 = "5초후 게헨나스의 저주!",
	warn2 = "게헨나스의 저주 - 다음 저주 30초후!",

	bar1text = "게헨나스의 저주",

	curse = "게헨나스의 저주 경고",
	curse_desc = "게헨나스의 저주에 대한 경고",

	fire = "불의 비",
	fire_desc = "자신에게 불의 비가 내릴때를 알림니다.",
	fire_you = "당신은 불의 비!",
} end)

L:RegisterTranslations("deDE", function() return {
	warn1 = "Gehennas Fluch in 5 Sekunden!",
	warn2 = "Gehennas Fluch! N\195\164chster in 30 Sekunden!",

	bar1text = "Gehennas Fluch",

	curse = "Gehennas Fluch",
	curse_desc = "Warnung, wenn Gehennas AoE Fluch wirkt.",

	fire = "Feuerregen",
	fire_desc = "Warnt wenn Feuerregen auf dir ist.",
	fire_you = "Feuerregen auf DIR!",
} end)

L:RegisterTranslations("frFR", function() return {
	warn1 = "5 sec. avant Malédiction de Gehennas !",
	warn2 = "Malédiction de Gehennas - 30 sec. avant la prochaine !",

	bar1text = "Malédiction de Gehennas",

	curse = "Malédiction de Gehennas",
	curse_desc = "Préviens de l'arrivée des Malédictions de Gehennas.",

	fire = "Pluie de feu",
	fire_desc = "Prévient quand la Pluie de feu est sur vous.",
	fire_you = "Pluie de feu sur VOUS !",
} end)

----------------------------------
--      Module Declaration      --
----------------------------------

local mod = BigWigs:NewModule(boss)
mod.zonename = BZ["Molten Core"]
mod.enabletrigger = boss
mod.guid = 12259
mod.toggleoptions = {"curse", "fire", "bosskill"}
mod.revision = tonumber(("$Revision: 174 $"):sub(12, -3))

------------------------------
--      Initialization      --
------------------------------

function mod:OnEnable()
	self:AddCombatListener("SPELL_CAST_SUCCESS", "Curse", 19716)
	self:AddCombatListener("SPELL_AURA_APPLIED", "Fire", 19717)
	self:AddCombatListener("UNIT_DIED", "BossDeath")

	db = self.db.profile
end

------------------------------
--      Event Handlers      --
------------------------------

function mod:Curse()
	if db.curse then
		self:Bar(L["bar1text"], 30, 19716)
		self:IfMessage(L["warn2"], "Important", 19716)
		self:DelayedMessage(25, L["warn1"], "Urgent")
	end
end

function mod:Fire(player)
	if db.fire and player == pName then
		self:LocalMessage(L["fire_you"], "Urgent", 19717, "Alarm")
	end
end
