﻿------------------------------
--      Are you local?      --
------------------------------

local boss = BB["Lucifron"]
local L = AceLibrary("AceLocale-2.2"):new("BigWigs"..boss)

local db = nil
local fmt = string.format

----------------------------
--      Localization      --
----------------------------

L:RegisterTranslations("enUS", function() return {
	cmd = "Lucifron",

	curse = "Lucifron's Curse alert",
	curse_desc = "Warn for Lucifron's Curse",

	doom = "Impending Doom alert",
	doom_desc = "Warn for Impending Doom",

	mc = "Mind Control alert",
	mc_desc = "Warn about afflicted players",

	icon = "Place Icon",
	icon_desc = "Place a skull icon on the mind controlled person (requires promoted or higher)",

	curse_message = "Lucifron's Curse - 20 seconds until next!",
	curse_warn = "5 seconds until Lucifron's Curse!",
	curse_bar = "Lucifron's Curse",

	doom_message = "Impending Doom - 20 seconds until next!",
	doom_warn = "5 seconds until Impending Doom!",
	doom_bar = "Impending Doom",

	mc_message = "%s is Mind Controlled!",
	mc_bar = "MC: %s",
} end)

L:RegisterTranslations("zhCN", function() return {
	curse = "诅咒警报",
	curse_desc = "诅咒警报",

	doom = "末日降临警报",
	doom_desc = "末日降临警报",

	mc = "精神控制警报",
	mc_desc = "受到精神控制发出警报",

	icon = "设置标记",
	icon_desc = "为受到精神控制的队友打上标记(需要助理A或者更高的权限)",

	curse_message = "鲁西弗隆的诅咒 - 20秒后再次发动!",
	curse_warn = "5秒后发动鲁西弗隆的诅咒！",
	curse_bar = "鲁西弗隆的诅咒",

	doom_message = "末日降临 - 20秒后再次发动",
	doom_warn = "5秒后发动末日降临！",
	doom_bar = "末日降临",

	mc_message = "%s被精神控制",
	mc_bar = "控制: %s",
} end)

L:RegisterTranslations("zhTW", function() return {
	curse = "詛咒警報",
	curse_desc = "當魯西弗隆使用群體詛咒技能時發出警報",

	doom = "末日降臨警報",
	doom_desc = "當魯西弗隆使用末日降臨技能時發出警報",

	--mc = "Mind Control alert",
	--mc_desc = "Warn about afflicted players",

	icon = "標記被精神控制的隊友",
	icon_desc = "在被精神控制的隊友頭上設置標記 (需要助手或領隊權限)",

	curse_message = "群體詛咒 - 20 秒後再次發動",
	curse_warn = "群體詛咒 5 秒後發動！",
	curse_bar = "群體詛咒",

	doom_message = "末日降臨 - 20 秒後再次發動",
	doom_warn = "末日降臨 5 秒後發動！",
	doom_bar = "末日降臨",

	--mc_message = "%s is Mind Controlled!",
	--mc_bar = "MC: %s",
} end)

L:RegisterTranslations("koKR", function() return {
	curse = "루시프론의 저주 경고",
	curse_desc = "루시프론의 저주에 대한 경고",

	doom = "파멸의 예언 경고",
	doom_desc = "파멸의 예언에 대한 경고",

	mc = "정신 지배 경고",
	mc_desc = "정신 지배에 걸린 사람에 대한 경고",

	icon = "아이콘 지정",
	icon_desc = "정신 지배된 사람에게 해골 아이콘 지정 (승급자 이상 필요)",

	curse_message = "루시프론의 저주 - 다음 저주는 20초후!",
	curse_warn = "5초후 루시프론의 저주!",
	curse_bar = "루시프론의 저주",

	doom_message = "파멸의 예언 - 다음 예언은 20초후!",
	doom_warn = "5초후 파멸의 예언!",
	doom_bar = "파멸의 예언",

	mc_message = "%s 정신 지배!",
	mc_bar = "정배: %s",
} end)

L:RegisterTranslations("deDE", function() return {
	curse = "Lucifrons Fluch",
	curse_desc = "Warnung vor Lucifrons Fluch.",

	doom = "Drohende Verdammnis",
	doom_desc = "Warnung vor Drohender Verdammnis.",

	--mc = "Mind Control alert",
	--mc_desc = "Warn about afflicted players",

	icon = "Symbol",
	icon_desc = "Platziert ein Symbol \195\188ber dem Spieler, der unter Gedankenkontrolle steht. (Ben\195\182tigt Anf\195\188hrer oder Bef\195\182rdert Status.)",

	curse_message = "Lucifrons Fluch - N\195\164chster in 20 Sekunden!",
	curse_warn = "Lucifrons Fluch in 5 Sekunden!",
	curse_bar = "Lucifrons Fluch",

	doom_message = "Drohende Verdammnis - N\195\164chste in 20 Sekunden!",
	doom_warn = "Drohende Verdammnis in 5 Sekunden!",
	doom_bar = "Drohende Verdammnis",

	--mc_message = "%s is Mind Controlled!",
	--mc_bar = "MC: %s",
} end)

L:RegisterTranslations("frFR", function() return {
	curse = "Malédiction de Lucifron",
	curse_desc = "Préviens de l'arrivée des Malédictions de Lucifron.",

	doom = "Malédiction imminente",
	doom_desc = "Préviens de l'arrivée des Malédictions imminentes.",

	mc = "Contrôle mental",
	mc_desc = "Préviens quand un joueur subit les effets du Contrôle mental.",

	icon = "Icône",
	icon_desc = "Place une icône de raid sur le dernier joueur affecté par le Contrôle mental (nécessite d'être promu ou mieux).",

	curse_message = "Malédiction de Lucifron - 20 sec. avant la prochaine !",
	curse_warn = "5 sec. avant Malédiction de Lucifron !",
	curse_bar = "Malédiction de Lucifron",

	doom_message = "Malédiction imminente - 20 sec. avant la prochaine !",
	doom_warn = "5 sec. avant Malédiction imminente !",
	doom_bar = "Malédiction imminente",

	mc_message = "%s est sous Contrôle mental !",
	mc_bar = "CM : %s",
} end)

----------------------------------
--      Module Declaration      --
----------------------------------

local mod = BigWigs:NewModule(boss)
mod.zonename = BZ["Molten Core"]
mod.enabletrigger = boss
mod.guid = 12118
mod.toggleoptions = {"curse", "doom", -1, "mc", "icon", "bosskill"}
mod.revision = tonumber(("$Revision: 174 $"):sub(12, -3))

------------------------------
--      Initialization      --
------------------------------

function mod:OnEnable()
	self:AddCombatListener("SPELL_CAST_SUCCESS", "Doom", 19702)
	self:AddCombatListener("SPELL_CAST_SUCCESS", "Curse", 19703)
	self:AddCombatListener("SPELL_AURA_APPLIED", "MindControl", 20604)
	self:AddCombatListener("UNIT_DIED", "BossDeath")

	db = self.db.profile
end

------------------------------
--      Event Handlers      --
------------------------------

function mod:Doom()
	if db.doom then
		self:Bar(L["doom_bar"], 20, 19702)
		self:IfMessage(L["doom_message"], "Important", 19702)
		self:DelayedMessage(15, L["doom_warn"], "Urgent")
	end
end

function mod:Curse()
	if db.curse then
		self:Bar(L["curse_bar"], 20, 19703)
		self:IfMessage(L["curse_message"], "Important", 19703)
		self:DelayedMessage(15, L["curse_warn"], "Urgent")
	end
end

function mod:MindControl(player)
	if db.mc then
		self:Bar(fmt(L["mc_bar"], player), 15, 20604)
		self:IfMessage(fmt(L["mc_message"], player), "Important", 20604)
	end

	if db.icon then
		self:Icon(player)
	end
end
