﻿------------------------------
--      Are you local?      --
------------------------------

local boss = BB["Magmadar"]
local L = AceLibrary("AceLocale-2.2"):new("BigWigs"..boss)

local db = nil

----------------------------
--      Localization      --
----------------------------

L:RegisterTranslations("enUS", function() return {
	cmd = "Magmadar",

	fear = "Warn for Fear",
	fear_desc = "Warn when Magmadar casts AoE Fear",

	frenzy = "Frenzy alert",
	frenzy_desc = "Warn when Magmadar goes into a frenzy",

	frenzywarn = "Frenzy alert!",
	fearalert = "5 seconds until AoE Fear!",
	fearwarn = "AoE Fear - 30 seconds until next!",
	fearbar = "AoE Fear",
} end)

L:RegisterTranslations("koKR", function() return {
	fear = "공포 경고",
	fear_desc = "마그마다르 공포 시전 시 경고",

	frenzy = "광폭화 경고",
	frenzy_desc = "마그마다르 광폭화 시 경고",

	frenzywarn = "광폭화 경보 - 사냥꾼의 평정 사격을 쏘세요!",
	fearalert = "5초후 광역 공포!",
	fearwarn = "광역 공포 경보 - 다음 공포까지 30초!",
	fearbar = "광역 공포",
} end)

L:RegisterTranslations("zhCN", function() return {
	fear = "恐惧警报",
	fear_desc = "恐惧警报",

	frenzy = "狂暴警报",
	frenzy_desc = "狂暴警报",

	frenzywarn = "狂暴警报 - 猎人立刻使用宁神射击！",
	fearalert = "5秒后发动群体恐惧！",
	fearwarn = "群体恐惧 - 30秒后再次发动",
	fearbar = "群体恐惧",
} end)

L:RegisterTranslations("zhTW", function() return {
	fear = "群體恐懼警報",
	fear_desc = "當瑪格曼達發動群體恐懼效果時發出警報",

	frenzy = "狂暴警報",
	frenzy_desc = "當瑪格曼達狂暴時發出警報",

	frenzywarn = "狂暴狀態！ 獵人立刻使用寧神射擊！",
	fearalert = "5 秒後發動群體恐懼",
	fearwarn = "群體恐懼 - 30 秒後再次發動",
	fearbar = "群體恐懼",
} end)

L:RegisterTranslations("deDE", function() return {
	fear = "Furcht",
	fear_desc = "Warnung, wenn Magmadar AoE Furcht wirkt.",

	frenzy = "Raserei",
	frenzy_desc = "Warnung, wenn Magmadar in Raserei ger\195\164t.",

	frenzywarn = "Raserei! - Einlullender Schuss!",
	fearalert = "AoE Furcht in 5 Sekunden!",
	fearwarn = "AoE Furcht! N\195\164chste in 30 Sekunden!",
	fearbar = "AoE Furcht",
} end)

L:RegisterTranslations("frFR", function() return {
	fear = "Peur",
	fear_desc = "Préviens quand Magmadar lance sa peur de zone.",

	frenzy = "Frénésie",
	frenzy_desc = "Préviens quand Magmadar entre dans une frénésie sanglante.",

	frenzywarn = "Frénésie !",
	fearalert = "Peur de zone dans 5 sec. !",
	fearwarn = "Peur de zone ! - 30 sec. avant la prochaine",
	fearbar = "Peur de zone",
} end)

----------------------------------
--      Module Declaration      --
----------------------------------

local mod = BigWigs:NewModule(boss)
mod.zonename = BZ["Molten Core"]
mod.enabletrigger = boss
mod.guid = 11982
mod.toggleoptions = {"fear", "frenzy", "bosskill"}
mod.revision = tonumber(("$Revision: 174 $"):sub(12, -3))

------------------------------
--      Initialization      --
------------------------------

function mod:OnEnable()
	self:AddCombatListener("SPELL_CAST_SUCCESS", "Fear", 19408)
	self:AddCombatListener("SPELL_CAST_SUCCESS", "Frenzy", 19451)
	self:AddCombatListener("UNIT_DIED", "BossDeath")

	db = self.db.profile
end

------------------------------
--      Event Handlers      --
------------------------------

function mod:Fear()
	if db.fear then
		self:Bar(L["fearbar"], 30, 19408)
		self:IfMessage(L["fearwarn"], "Important", 19408)
		self:DelayedMessage(25, L["fearalert"], "Urgent")
	end
end

function mod:Frenzy()
	if db.frenzy then
		self:IfMessage(L["frenzywarn"], "Important", 19451, "Alert")
	end
end
