﻿------------------------------
--      Are you local?      --
------------------------------

local boss = BB["Majordomo Executus"]
local L = AceLibrary("AceLocale-2.2"):new("BigWigs"..boss)

local db = nil
local aura

----------------------------
--      Localization      --
----------------------------

L:RegisterTranslations("enUS", function() return {
	disabletrigger = "Impossible! Stay your attack, mortals... I submit! I submit!",

	warn1 = "Magic Reflection for 10 seconds!",
	warn2 = "Damage Shield for 10 seconds!",
	warn3 = "5 seconds until powers!",
	warn4 = "Magic Reflection down!",
	warn5 = "Damage Shield down!",

	bar1text = "Magic Reflection",
	bar2text = "Damage Shield",
	bar3text = "New powers",

	cmd = "Majordomo",

	magic = "Magic Reflection alert",
	magic_desc = "Warn for Magic Reflection",

	dmg = "Damage Shields alert",
	dmg_desc = "Warn for Damage Shields",
} end)

L:RegisterTranslations("zhCN", function() return {
	disabletrigger = "不可能！等一下",

	warn1 = "魔法反射护盾，持续10秒！",
	warn2 = "伤害反射护盾，持续10秒！",
	warn3 = "5秒后释放反射护盾！",
	warn4 = "魔法反射护盾已消失！",
	warn5 = "伤害反射护盾已消失！",

	bar1text = "魔法反射护盾",
	bar2text = "伤害反射护盾",
	bar3text = "新生力量",

	magic = "魔法反射护盾警报",
	magic_desc = "魔法反射护盾警报",
	
	dmg = "伤害反射护盾警报",
	dmg_desc = "伤害反射护盾警报",
} end)

L:RegisterTranslations("zhTW", function() return {
	disabletrigger = "不……不可能！等一下……我投降！我投降！",

	warn1 = "== 法術停火 == 魔法反射，持續10秒",
	warn2 = "== 近戰停火 == 傷害反射護盾，持續10秒",
	warn3 = "5秒後施放效果！",
	warn4 = "魔法反射已消失！",
	warn5 = "傷害護盾已消失！",

	bar1text = "魔法反射",
	bar2text = "傷害護盾",
	bar3text = "新生力量",

	magic = "魔法反射警報",
	magic_desc = "通報週期性施放的魔法反射",

	dmg = "傷害護盾警報",
	dmg_desc = "通報週期性施放的傷害護盾",
} end)

L:RegisterTranslations("koKR", function() return {
	disabletrigger = "이럴 수가! 그만! 제발 그만! 내가 졌다! 내가 졌어!",

	warn1 = "마법 보호막 - 10초간!",
	warn2 = "피해 보호막 - 10초간!",
	warn3 = "5초후 버프!",
	warn4 = "마법 반사 사라짐!",
	warn5 = "피해 보호 사라짐!",

	bar1text = "마법 반사",
	bar2text = "피해 보호막",
	bar3text = "새로운 버프",

	magic = "마법 보호막 경고",
	magic_desc = "마법 보호막에 대한 경고",

	dmg = "피해 보호막 경고",
	dmg_desc = "피해 보호막에 대한 경고",
} end)

L:RegisterTranslations("deDE", function() return {
	disabletrigger = "Haltet ein, Sterbliche",

	warn1 = "Magiereflexion f\195\188r 10 Sekunden!",
	warn2 = "Schadensschild f\195\188r 10 Sekunden!",
	warn3 = "Schild in 5 Sekunden!",
	warn4 = "Magiereflexion beendet!",
	warn5 = "Schadensschild beendet!",

	bar1text = "Magiereflexion",
	bar2text = "Schadensschild",
	bar3text = "N\195\164chstes Schild",

	magic = "Magiereflexion",
	magic_desc = "Warnung, wenn Magiereflexion aktiv.",

	dmg = "Schadensschild",
	dmg_desc = "Warnung, wenn Schadensschild aktiv.",
} end)

L:RegisterTranslations("frFR", function() return {
	disabletrigger = "Impossible ! Arrêtez votre attaque, mortels... Je me rends ! Je me rends !",

	warn1 = "Renvoi de la magie pendant 10 sec. !",
	warn2 = "Bouclier de dégâts pendant 10 sec. !",
	warn3 = "5 sec. avant Bouclier/Renvoi !",
	warn4 = "Renvoi de la magie dissipée !",
	warn5 = "Bouclier de dégâts dissipé !",

	bar1text = "Renvoi de la magie",
	bar2text = "Bouclier de dégâts",
	bar3text = "Prochain Bouclier/Renvoi",

	magic = "Renvoi de la magie",
	magic_desc = "Préviens si les Attise-flammes sont protégés par des Renvois de la magie.",

	dmg = "Bouclier de dégâts",
	dmg_desc = "Préviens si les Attise-flammes sont protégés par des Boucliers de dégâts.",
} end)

----------------------------------
--      Module Declaration      --
----------------------------------

local mod = BigWigs:NewModule(boss)
mod.zonename = BZ["Molten Core"]
mod.enabletrigger = boss
mod.guid = 12018
mod.toggleoptions = { "magic", "dmg", "bosskill" }
mod.revision = tonumber(("$Revision: 174 $"):sub(12, -3))

------------------------------
--      Initialization      --
------------------------------

function mod:OnEnable()
	self:AddCombatListener("SPELL_CAST_SUCCESS", "MagicGain", 20619)
	self:AddCombatListener("SPELL_AURA_REMOVED", "MagicLoss", 20619)
	self:AddCombatListener("SPELL_CAST_SUCCESS", "DmgGain", 21075)
	self:AddCombatListener("SPELL_AURA_REMOVED", "DmgLoss", 21075)

	self:RegisterEvent("CHAT_MSG_MONSTER_YELL")

	aura = nil
	db = self.db.profile
end

function mod:VerifyEnable(unit)
	return UnitCanAttack("player", unit)
end

------------------------------
--      Event Handlers      --
------------------------------

function mod:CHAT_MSG_MONSTER_YELL(msg)
	if msg == L["disabletrigger"] then
		self:BossDeath(nil, self.guid)
	end
end

function mod:MagicGain()
	aura = true
	if db.magic then
		self:Bar(L["bar3text"], 30, "Spell_Frost_Wisp")
		self:Bar(L["bar1text"], 10, 20619)
		self:IfMessage(L["warn1"], "Important", 20619)
	end
	self:DelayedMessage(25, L["warn3"], "Urgent")
end

function mod:MagicLoss()
	if aura and db.magic then
		self:Message(L["warn4"], "Attention", 20619)
	end
	aura = nil
end

function mod:DmgGain()
	aura = true
	if db.dmg then
		self:Bar(L["bar3text"], 30, "Spell_Frost_Wisp")
		self:Bar(L["bar2text"], 10, 21075)
		self:IfMessage(L["warn2"], "Important", 21075)
	end
	self:DelayedMessage(25, L["warn3"], "Urgent")
end

function mod:DmgLoss()
	if aura and db.dmg then
		self:Message(L["warn5"], "Attention", 21075)
	end
	aura = nil
end
