﻿------------------------------
--      Are you local?      --
------------------------------

local boss = BB["Shazzrah"]
local L = AceLibrary("AceLocale-2.2"):new("BigWigs"..boss)
local db = nil

----------------------------
--      Localization      --
----------------------------

L:RegisterTranslations("enUS", function() return {
	warn1 = "Blink - ~45 seconds until next!",
	warn2 = "~5 seconds to Blink!",
	warn3 = "Shazzrah buffed himself!",

	bar1text = "Blink",

	cmd = "Shazzrah",

	selfbuff = "Self Buff Alert",
	selfbuff_desc = "Warn when Shazzrah casts a Self Buff",

	blink = "Blink Alert",
	blink_desc = "Warn when Shazzrah Blinks",
} end)

L:RegisterTranslations("zhCN", function() return {
	warn1 = "闪现术 - ~45秒后再次发动",
	warn2 = "~5秒后发动闪现术！",
	warn3 = "自我Buff - 驱散魔法！",

	bar1text = "闪现术",

	selfbuff = "自我Buff警报",
	selfbuff_desc = "沙斯拉尔自我Buff时发出警报",

	blink = "闪现术警报",
	blink_desc = "沙斯拉尔发动闪现术时发出警报",
} end)

L:RegisterTranslations("zhTW", function() return {
	warn1 = "閃現術 - 45 秒後再次發動！",
	warn2 = "5 秒後發動閃現術！",
	warn3 = "自我 Buff - 驅散魔法",

	bar1text = "閃現術",

	selfbuff = "自我Buff警報",
	selfbuff_desc = "沙斯拉爾自我Buff時發出警報",

	blink = "閃現術警報",
	blink_desc = "沙斯拉爾發動閃現術時發出警報",
} end)

L:RegisterTranslations("koKR", function() return {
	warn1 = "점멸 - ~45초후 재점멸!",
	warn2 = "~5초후 점멸!",
	warn3 = "마법 약화 버프 - 마법 무효화를 사용하세요!",

	bar1text = "점멸",

	selfbuff = "약화 디버프 경고",
	selfbuff_desc = "샤즈라가 약화 디버프 시전시 경고",

	blink = "점멸 경고",
	blink_desc = "샤즈라 점멸 시 경고",
} end)

L:RegisterTranslations("deDE", function() return {
	warn1 = "Portal! N\195\164chstes in ~45 Sekunden!",
	warn2 = "Portal in ~5 Sekunden!",
	warn3 = "Magied\195\164mpfer auf Shazzrah!",

	bar1text = "Portal",

	selfbuff = "Selbstbuff",
	selfbuff_desc = "Warnung, wenn Magied\195\164mpfer auf Shazzrah.",

	blink = "Portal",
	blink_desc = "Warnung, wenn Shazzrah Portal wirkt.",
} end)

L:RegisterTranslations("frFR", function() return {
	warn1 = "Transfert - ~45 sec. avant le prochain !",
	warn2 = "~5 sec. avant Transfert !",
	warn3 = "Shazzrah gagne Amortissement de la magie !",

	bar1text = "Transfert",

	selfbuff = "Amortissement de la magie",
	selfbuff_desc = "Préviens quand Shazzrah gagne son Amortissement de la magie.",

	blink = "Transfert",
	blink_desc = "Préviens quand Shazzrah effectue un Transfert.",
} end)

----------------------------------
--      Module Declaration      --
----------------------------------

local mod = BigWigs:NewModule(boss)
mod.zonename = BZ["Molten Core"]
mod.enabletrigger = boss
mod.guid = 12264
mod.toggleoptions = {"selfbuff", "blink", "bosskill"}
mod.revision = tonumber(("$Revision: 175 $"):sub(12, -3))

------------------------------
--      Initialization      --
------------------------------

function mod:OnEnable()
	self:AddCombatListener("SPELL_CAST_SUCCESS", "Blink", 23138)
	self:AddCombatListener("SPELL_CAST_SUCCESS", "SelfBuff", 19714)
	self:AddCombatListener("UNIT_DIED", "BossDeath")

	db = self.db.profile
end

------------------------------
--      Event Handlers      --
------------------------------

function mod:Blink()
	if db.blink then
		self:Bar(L["bar1text"], 45, 23138)
		self:IfMessage(L["warn1"], "Important", 23138)
		self:DelayedMessage(40, L["warn2"], "Urgent")
	end
end

function mod:SelfBuff()
	if db.selfbuff then
		self:IfMessage(L["warn3"], "Important", 19714)
	end
end
