﻿------------------------------
--      Are you local?      --
------------------------------

local boss = BB["Sulfuron Harbinger"]
local L = AceLibrary("AceLocale-2.2"):new("BigWigs"..boss)

local db = nil

----------------------------
--      Localization      --
----------------------------

L:RegisterTranslations("enUS", function() return {
	cmd = "Sulfuron",

	inspire = "Inpire Gain Alert",
	inspire_desc = "Warn when Sulfuron gains Inspire",

	heal = "Heal Alert",
	heal_desc = "Warn when a Flamewaker Priest starts healing",

	inpire_message = "Sulfuron gains Inspire!",
	inspire_bar = "Inspire",

	heal_message = "A Flamewaker Priest is healing!",
	heal_bar = "Dark Mending",
} end)

L:RegisterTranslations("frFR", function() return {
	inspire = "Inspirer",
	inspire_desc = "Préviens quand le Messager de Sulfuron gagne Inspirer.",

	heal = "Soins",
	heal_desc = "Préviens quand un Prêtre Attise-flammes commence à lancer un soin.",

	inpire_message = "Sulfuron gagne Inspirer !",
	inspire_bar = "Inspirer",

	heal_message = "Un Prêtre Attise-flammes lance un soin !",
	heal_bar = "Guérison ténébreuse",
} end)

L:RegisterTranslations("zhCN", function() return {
	inspire= "灵感获得警报",
	inspire_desc = "当萨弗隆先驱者获得灵感发出警报",

	heal = "治疗警报",
	heal_desc = "当烈焰行者祭司开始治疗发出警报",

	inpire_message = "萨弗隆获得了灵感！",
	inspire_bar = "灵感",

	heal_message = "烈焰行者祭司施放治疗 - 打断！",
	heal_bar = "治疗",
} end)


L:RegisterTranslations("zhTW", function() return {
	cmd = "薩弗隆先驅者",

	inspire = "Inpire Gain Alert",
	inspire_desc = "Warn when Sulfuron gains Inspire",

	heal = "治療警報",
	heal_desc = "當火焰行者施放黑暗治療時發出警報",

	inpire_message = "Sulfuron gains Inspire!",
	inspire_bar = "Inspire",

	heal_message = "A Flamewaker Priest is healing!",
	heal_bar = "黑暗治療",
} end)

----------------------------------
--      Module Declaration      --
----------------------------------

local mod = BigWigs:NewModule(boss)
mod.zonename = BZ["Molten Core"]
mod.enabletrigger = boss
mod.guid = 12098
mod.toggleoptions = {"inspire", -1, "heal", "bosskill"}
mod.revision = tonumber(("$Revision: 174 $"):sub(12, -3))

------------------------------
--      Initialization      --
------------------------------

function mod:OnEnable()
	self:AddSyncListener("SPELL_CAST_START", "SulfuronHeal", 19775)
	self:AddCombatListener("SPELL_CAST_SUCCESS", "Inspire", 19779)
	self:AddCombatListener("UNIT_DIED", "BossDeath")

	self:RegisterEvent("BigWigs_RecvSync")
	self:Throttle(2.5, "SulfuronHeal")

	db = self.db.profile
end

------------------------------
--      Event Handlers      --
------------------------------

function mod:Inspire()
	if db.inspire then
		self:Bar(L["inspire_bar"], 10, 19779)
		self:IfMessage(L["inpire_message"], "Attention", 19779)
	end
end

function mod:BigWigs_RecvSync(sync)
	if sync == "SulfuronHeal" and db.heal then
		self:Bar(L["heal_bar"], 2, 19775)
		self:Message(L["heal_message"], "Important", 19775)
	end
end
